﻿// Education C++ UE.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include<string>
#include <cmath>

using namespace std;
#define Pi 3.14159 // макрос #define поределяет переменную Pi равную 3.14159
#define printIn(X) cout<<X<<endl;// создали макрос с аргументом Х


inline int max(int a, int b) //встроенная функция, используется вместо макроса, особенно вместо большого макроса
{                           // у встроенной функции копируются строки в место вызова, тем самым переход не требуется
    if (a > b) return a;
                           //применение встроенных функций обычно имеет смысл для маленьких, простых функций, которые имеют не большое количество строк
    else return b;
    
}



string g_string; /*Глобальная переменная , которая доступна всем функциям в программеб 
                 потому, что она объявлена до всех функций в программе ниже
                 как правил g_ ставится для показания, того, что пременная является глобальной, чтобы
                 можно было отделить глобальные от локальных*/

void addA()
{
    g_string += "A";
}
void addB()
{
    g_string += "B";
}
void addC()
{
    g_string += "C";  // продолжение на строке 670+
}

int g_int; //область глобальной int до конца файла

void func(int arg)
{
    int fx;                     //fx уже локальная переменная, недосягаемая для остальных функций и работает только в данной функции внутри
}                               // int fx уже не досягаемо arg заканчивается


void testFunc()
{
     static int runCount = 0; // запускается только один раз, даже при повторном вызове функции static - статическая функция
    cout << "Launch this function " <<  ++ runCount << " once" << endl; //++ нужны чтобы вести подсчет сколько раз была запущена функция 1, 2, 3 считает 
    // только статичные функции

}       //end of this function it's still active inside             // go to line 750+


class Player1    //объявили класс Player ниже изначальный класс struct
{
private:
    string name = "Kirill"; // в данном случае объект по-умолчанию приватный private
    int hp;

public:
    string getName()        // здесь установили функцию геттер, который берет информацию из pivate
    {
        return name;            
    }
    string getname1() const // если мы поставим const, то при вызове данной функции мы не сможем подставить какие либо значения 
    {
        return name;
    }
    void setName(string newName)  // функция позволяет изменять данные в private зоне, вданном случае у name
    {
        name = newName;

    }
    void setHP(int newHP)       // метод мутатора (геттера или сеттера) предполагает предотвращение принятия отрицательного значения внутренним элементом данных hp
    {
        if (newHP < 0)
        {
            cout << "Hp cannot be less than 0" << endl;
            newHP = 0;
        }
        hp = newHP;
    }


};

struct Armor
{
    string name;
    int armorClass;
    double durability;

};



struct Vector // Определение объекта вектор
{
    float x, y, z; // Setting float x y and z


};      /* конец определения объекта Vector, 
        компьютер теперь знает, чем является Vector, 
        теперь я могу создавать объект типа Vector
        */

struct Player       // класс struct изначально создается с публичными данными public, т.е. все данные публичны(открыты),и чтобы они были закрыты
    // необходимо внести соответствующие команды private для определения доступности данных извне 
{

                 // приватные данные, доступ к ним ограничен, сюда нет доступа извне
    string name;
    int hp;
    Vector position;  //  struct Vector
    int armorClass;   
    Armor armor; //теперь Player обладает armor, мы создали отдельно класс stuct Armor
    
                                /* Мы поместили объект Vector в объект Player,
                                 тем самым определили возможность объекту Player брать данные из объекта Vector* /
                            /*Здесь мы создали объект (структуру) и назвали ее Player (игрок), struct это по сути одна большая переменная, в которую включены остальные
                            далее внутри структуры игрока присвоили переменные дав name (имя), hp (жизни), position (позиция)
                                   т.е. в структуре Player есть Имя, очки здоровья и место нахождения в 3D мире*/
                     // далее внутрь struct мы также заносим функцию член уменьшающее здоровье игрока и увеличивающие его, функция-член это обычная функция обЪявленная
                      // внутри struct, по сути дела локальная функция, данные функции могут использовать все данные struct Player
                            
                             // Публичная часть функции, здесь данные можно изменить извне
    void damage(int amount)
    {
        this->hp -= amount;     //ключевое слово this - это указатель, действующий на текущий объект, this имеет смысл только внутри функции-члена
    }                        // без написания this имеется ввиду, что мы говорим о hp данного объекта

private:
    void recover(int amount)
    {
        this->hp += amount;
    }
    void damagewitharmor(int dmgAmount)             //Оюъектно ориентированный вариант прогаммирования и нанесения урона
    {   
        int reduction = dmgAmount - armorClass;     
        if (reduction < 0)          // убеждается, что не отрицательное число, если отрицательное
            reduction = 0;          // то reduction присваивает значение 0
        hp -= reduction;
        
    }



};

enum Food //определяем новый тип переменной Food
{
    Fish,
    Bread,
    Apple, Orange, Banana     // мы можем хранить любое количество значений (названий) в Food

};

void printRoad(int numSegments)    //название функции которую мы создали типа void, int numSegments - аргумент функции, который также является параметром
//  и сможет выводить ту строку функции, которую мы запросим
{
    for (int i = 0; i < numSegments; i++)
    {
        cout << "*   *" << endl;// тело функции, в котором прописаны условия
        cout << "* | *" << endl;
        cout << "* | *" << endl;
        cout << "*   *" << endl;

    }
}

void myFunction()
{
    cout << "What's happened?" << endl;
}

int summa(int m, int z)
{
    return m + z;
}

bool isPositive(double value)
{
    return value > 0;

}


bool  absEqual(int a, int b)
{// делаем a и b положительными
    if (a < 0)
        a = -a;
    if (b < 0)
        b = -b;      
    // теперь a и b положительные, просто сравниваем на равность
         return a==b;

}


char getGrade(int grade) // char обязательно иначе будет выводить непонятные значения
{
    if (grade >= 80)

        return 'A';
    else if (grade >= 70)
        return 'B';
    else if (grade >= 60)
        return 'C';
    else if (grade >= 50)
        return 'D';
    else
        return 'F';
       
    
   
}

int mathfunction(int x)
{
    return 3 * x + 4;

}


bool isPositive(double value);      // это прототипы функций, которые не содержат тела функции {} т.е. нет фигурных скобок
bool absEqual(int a, int b);        // обычно тело функции располагается в .h файле, а тело в .cpp файле
char getGrade(int grade);        // причина, в том, чтобы включить .h файл в .срр файл и не получить множество ошибок определения


int main()
{
    cout << "Hello World!\n";
    cout << "I am a C++ programmer now!" << endl;

    string name;
    int goldpieces;
    int hp;
    name = "Kirill";
    goldpieces = 322;
    hp = 75;

    cout << "Character " << name << " has " << hp << " hp and " << goldpieces << " gold" << endl;
    hp -= 15; //or hp = hp - 15;
    cout << "hp now is " << hp << endl;
    hp += 20;// or hp = hp+20;
    cout << "your hp now is " << hp << endl;
    hp *= 2; // or hp = hp*2;
    cout << "your hp now is " << hp << endl;
    hp /= 2; // or hp = hp/2;
    cout << "HP is " << hp << endl;


    Vector v; // Создаем объект Vector с названием v
    v.x = 20, v.y = 30, v.z = 40; // присваиваем значения вектору v
    cout << "A 3-D space vector at x=" << v.x << ", y=" << v.y << ", z=" << v.z << endl;


    Player me; // Объекту Player дано имя me
    me.name = "Kirill";// через присвоенное значение me даем определение переменным name, hp, position
    me.hp = 100;
    me.position.x = me.position.y = me.position.z = 0;
    cout << me.name << " HP=" << me.hp << " Place in 3D world: " << me.position.x << "," << me.position.y << "," << me.position.z << endl;

    Player* ptrMe; // объявление указателя
    ptrMe = &me; //связывание ptrME c me; оператор & получает адрес переменной в памяти, т.е. где она находится в памяти компьютера
    /* теперь ptrME при изменении также изменит и me*/

    ptrMe->hp -= 33; // знак -> используется всегда когда переменная является указателем, здесь мы изменили жизни
    ptrMe->name = "Cyrill"; // здесь с помощью указателя мы изменили изначальное имя через ->
    cout << me.name << " HP=" << me.hp << endl;

    int k = 22;
    cout << &k << endl; // c помощью & мы вывели не число 22, а адрес в памяти, где находится переменная k 
    int* pk;// здесь создаем переменную pk и ставим ссылку *(ссылка), сначала ссылка * затем связывание &

    pk = &k;/*здесь связываем переменную pk c переменной k,
                        используя связывание &; перед  связыванием обязательно необходимо создать ссылку, затем связывать
                        теперь при смене переменной pk, мы меняем данные в переменной k */
    cout << *pk << endl; // через *pk выводим значения, которые записаны в переменной k, если ввести pk выведется адрес переменной k


    //cin - ввод данных в программу
    int age;
    cout << "What is your age " << endl;
    cin >> age;

    // printf()- является альтернативой cout, некоторые программисты предпочитают использовать данную команду вместо cout
    char character = 'A';
    int integer = 1;
    printf("integer %d,character %c\n", integer, character);
    string s = "Hello";
    printf("string %s\n", s.c_str());

    cout << "Hello dear user what is your name?" << endl;
    string myname;
    cin >> myname;
    cout << "What is your age, can you tell me again?" << endl;
    cin >> age;
    cout << "Hello " << myname << " i see you are " << age << " years old, Congratulations!" << endl;

    int x1 = 4;
    int y1 = 5;
    cout << "Is equal to y1? C++ says " << (x1 == y1) << endl;// ответ будет 0, 0 означает false, 1 означает true
    cout << "Is equal to y1? C++ says " << boolalpha << (x1 == y1) << endl; /* впри использовании boolalpha, затем ==
                                                                ответ будет написан либо true либо false, вместо 0 и 1 */
    cout << "x1 = " << x1 << " y1 = " << y1 << endl;

    bool isHungry = true;
    if (isHungry)/*Заходит внутрь и если голоден(true) тогда cooking, eating и sitting on sofa,
                 также можно написать if (isHungry == true), в примере ниже будет стоять знак == */
    {
        cout << "Cooking" << endl;
        cout << "eating..." << endl;

    }

    cout << "Sitting on sofa" << endl;

    cout << "Is equal to y1? C++ says " << (x1 = y1) << endl;// в данном случае мы просто переписали значение х1 и присвоили ему значение у1
    cout << "x1 = " << x1 << " y1 = " << y1 << endl;


    bool Hungry = false;
    if (Hungry == true) // Также можно написать if (Hungry) в данном случае условия выражения будут идентичными
    {
        cout << "Cooking" << endl;
        cout << "eating..." << endl;

    }                    // Закрывается скобка, для завершения опреатора if
    else    /*Выполняется в данном случае, если мы не голодны и isHungry = False*/
    {       // Оператор else всегда идет сразу за оператором if без дополнительных строк между if и else
            // никогда не идти в оба блока if и else, всегда запускается либо один либо другой
        cout << "I'm not Hungry" << endl;
    }
    cout << "Sitting on sofa" << endl;


    int x2 = 9;
    int y2 = 7;

    cout << "Is x2 bigger than y2? " << (x2 > y2) << endl;
    cout << "Is x2 bigger or equal y2? " << (x2 >= y2) << endl;
    cout << "Is x2 less than y2 " << (x2 < y2) << endl;
    cout << "Is x2 less or equal y2? " << (x2 <= y2) << endl;
    cout << "Is x2 not equal y2? " << (x2 != y2) << endl;


    bool wearingSocks = true;
    if (!wearingSocks) /* тоже самое если мы напишем if (false == wearingSocks), тем самым мы поменяли значение переменной с true на false
       Аналогично мы можем написать if (!!wearingSocks), тогда выражение станет опять противоположно,
       т.е. противоположно противоположному, иначе снова стане if(wearingSocks==true)*/


    {
        cout << "wear Socks" << endl;

    }
    else
    {
        cout << "socks Weared" << endl;

    }

    bool hidden = true; // hidden = true
    bool isVisible = !hidden;/*bool isVisible становится равным false, т.к.перед hidden мы поставили !,
                             тем самым поменяв значения с true на false. В дальнейшем isVisible запишется, как равная false */

                             // Оператор И (&&)

    bool wearingClothes = true;
    if (wearingClothes && !wearingSocks)
    {
        cout << "Clothes on me" << endl;
    }
    else
    {
        cout << "you are naked" << endl;
    }

    // оператор ИЛИ (||) требует, чтобы хотябы одна переменная была равна true

    if (wearingClothes || !wearingSocks)
    {
        cout << "Clothes on me" << endl;
    }
    else
    {
        cout << "you are naked" << endl;
    }

    bool foundStar = true;// найдена звезда 
    float levelCompleteTime = 25.0f; /*время завершения уровня, если мы поставим !(не)к числу это не будет иметь значения,
                                     т.к.не изменит значение на противоположное как true на false, т.е. значение останется 25.0f,
                                     даже если мы поставим значение 25  ничего не изменится, все равно будет равно изначальному числу */
    float maxTimeForBonus = 60.0f; // максимальное время для бонуса

    if (!foundStar || levelCompleteTime < maxTimeForBonus)
    {
        cout << "Earn Bonus" << endl;
    }
    else
    {
        cout << "No Bonus" << endl;

    }





    int x3, y3;

    cin >> x3 >> y3; /*Можно так же, как и при выводе cout писать все в одной строке при необходимости
                 и не вписывать cin к каждому х и у отдельно*/

    if (x3 > y3)
    {
        cout << "x3 is bigger than y3" << endl;
    }
    else
    {
        cout << "x3 is less than y3" << endl;

    }

    /* Оператор  else if

    можем использовать когда условий больше чем одно,
    к примеру триб при условии срабатывания одного из условий будет срабатывать та строка кода,
    которая принадлежит срабатываемому условию.

    В данном случае отлично подойдет притча из сказки каким путем пойдешь, то и будет, и соответственно сработает один из 3 вариантов кода
    */

    enum Item // enum определяет новый тип переменной
    {
        Coin, Key, Sanddollar // переменные типа item могут содержать любое из этих трех значений

    };
    Item iteminHand = Coin; // как вариаент можно изменить значение и увидеть какой выйдет результат coin на Key или sanddollar
    if (iteminHand == Key)
    {
        cout << "the key with lion's head\n";
        cout << "you are entering secret room" << endl;
    }
    else if (iteminHand == Coin)
    {
        cout << "Coin with picture: lady " << endl;
        cout << "you can buy several things with this coin" << endl;
    }
    else if (iteminHand == Sanddollar)
    {
        cout << "This Sanddollar has small star\n";
        cout << "you can change  it on something else\n";

    }


    int x4;
    int y4;
    cout << "Enter an integer value for x4: \n ";
    cin >> x4;
    cout << "Enter an integer value for y4: " << endl;
    cin >> y4;
    cout << "x4 = " << x4 << " y4 = " << y4 << endl;
    if (x4 == y4)
    {
        cout << "x4 and y4 are equal\n";

    }
    else if (x4 < y4)
    {
        cout << "x4 is less than y4" << endl;
    }
    else if (x4 > y4)
    {
        cout << "x4 is bigger than y4\n";
    }



    // Оператор Switch
    /*оператор switch позволяет коду разветвляться по множеству путей, оператор будет смотреть на значение ппеременной,
    и взависимости от текущей переменной код пойдет по одному из различных направлений*/

    // в начале файла мы определили переменную Food через enum и внесли 4 варианта еды Fish, Bread, Apple, Orange


    Food food = Orange; // переменной Food добавили функцию food
    switch (food)
    {               /*  пишем код, который проверяет enum Food на food, проверяя чему равен в food в текущий момент и ища в
                    операторе switch нужную строку, к примеру если food = Bread, компилятор доходит до case Bread и удостоверившийсь, что это
                    case Bread выводит на консоль That's our bread, останавливая выполнение кода дальше в switch(food), останавливается он благодаря оператору break,
                    который останавливает программу при выполнении необходимого условия, если мы food приравняем к Banana,
                    не введя его в кейсы оператора switch, то исполнится default.

                    При food = cake код не скомпилируется, т.к. изначально в enum отстутствует класс еды cake, для того,чтобы код скомпилировался,
                    нам необходимо будет добавить cake в enum Food, но с кодом ниже сработает default,
                    т.к. мы не задали кейс (case) для cake, аналогично с примером Banana*/
    case Fish:
        cout << "Here is our fish\n";
        break;
    case Bread:
        cout << "That's our bread\n";
        break;
    case Apple:
        cout << "I wanna an apple\n";
        break;
    case Orange:
        cout << "Finally my orange" << endl;
        break;
    default:
        cout << "there is no what i want" << endl;
        break;



    }
    cout << "End of Switch" << endl;




    /* Switch похож на if / else / else if, но работает быстрее,
    т.к.ЦПУ обрабатывая оператор заканчивает его обработки при нахождении необходимого условия, в отличие от if / else где программа проверит,
    все условия, но if дает больше возможностей для уточнения необходимых параметров */


    /*enum также явлетсятипом intl для подтверждения выполним следующую программу*/

    cout << "Fish = " << Fish << " Bread = " << Bread << " Apple = " << Apple << " Orange = " << Orange << endl;

    //  каждому названию присвоено целочисленное число 0 1 2 3 


    enum Vegetables
    {
        Potato, Cabbage, Broccoli, Zucchini
    };
    Vegetables veg = Zucchini;
    switch (veg)
    {

    case Zucchini:
        cout << " No break " << endl;// после zucchini не было break, это означает, что после zucchini программа сразу проверяет следующую строку broccoli
    case Broccoli:// оператор break всегда важен, т.к. останавливает выполнение программы, при достижении условия (veg=Zucchini), иначе продолжит выполнять код далее
        cout << "weed" << endl;
        break;
    default:
        cout << "not a weed" << endl;
        break;                          //Важно вводить команду break после завершения метки case, иначе выполнение сценария продолжится далее, забрав с собой предыдущие


    }



    enum Raw
    {
        Wood,
        Food,
        Iron,
        Stone

    };
    Raw materials = Iron;
    switch (materials)
    {
    case Wood:
        cout << "Wood" << endl;
        break;
    case Food:
        cout << "Food" << endl;
        break;
    case Iron:
        cout << "Iron" << endl;
        break;
    case Stone:
        cout << "Stone" << endl;
        break;
    default:
        cout << "No Materials" << endl;
        break;
        /*В данном случае оператор switch прошел все ступени и вывел только, то условие,
        которое было равно Iron, и не забрал с собой все выше перечисленные, а именно Wood и Food, в отличие от  предыдущего варианта с Vegetables
        Это означает, что после условия case всегда необходимо ставить оператор break, чтобы завершать операцию и либо выводить case на консоль, либо переходить
        к следующему case условию, не забираю предыдущее

        В конце ставится default по умолчанию и желательно с командой break*/

    }


    enum Mount
    {
        Horse = 1,// т.к. мы поставили Horse = 1, то Mare= 2 Mule = 3 Sheep = 4 Chokobo =5
        Mare,
        Mule,
        Sheep,
        Chokobo
    };

    int mount;//Мы будем использовать переменную типа int для животных объявленных выше, cin  здесь будем работать и ввод будет через целые числа
    cout << "Check on which Animal you wanna ride: " << endl;
    cout << Horse << " Horse" << endl;
    cout << Mare << " Mare" << endl;
    cout << Mule << " Mule" << endl;
    cout << Sheep << " Sheep" << endl;
    cout << Chokobo << " Chokobo" << endl;
    cout << "enter digit from 1 to 5 to choose Animal" << endl;
    cin >> mount;
    switch (mount)
    {
    case Horse:
        cout << "Ride it" << endl;
        break;
    case Mare:
        cout << "Your baby Mare" << endl;
        break;
    case Mule:
        cout << "your favourite Mule" << endl;
        break;
    case Sheep:
        cout << "Riding on a sheep" << endl;
        break;
    case Chokobo:
        cout << "ride on Chokobo" << endl;
        break;
    default:
        cout << "you cannot ride on this" << endl;
        break;
    }

    // цикл while
    // циклы повторяют одну и ту же команду, или условие, пока не достигнут заданной границы, после чего останавливаются
    // по сути говоря это к примеру исполнение if йнесколько раз, к примеру 5, без необходиости писать if 5 раз
    int x5 = 1;
    while (x5 <= 5)  // мы задали значение x5=1 и вывели все значения которые меньше, либо равны 5, соответственно = true, 
        //как только !=true, результат становится false и цикл останавливается
    {
        cout << "x5 = " << x5 << endl;
        x5++;       // если мы не введем инкремент в данном случае, либо декремент, то программа будет повторяться бесконечно и выводить 1 не увеличивая значения
    }
    cout << "ready" << endl;


    int x6;
    cout << "Enter number from 1 to 10: " << endl;
    cin >> x6;
    while (x6 <= 10)
    {
        cout << "x6 = " << x6 << endl;
        x6 += 1;
    }
    cout << "Enter number from 10 to 1: " << endl;
    cin >> x6;
    while (x6 >= 1)
    {
        cout << "x6 = " << x6 << endl;
        x6 -= 1;
    }
    cout << "x7 +2 step" << endl;
    int x7 = 0;
    while (x7 <= 20)
    {
        cout << "x7 = " << x7 << endl;
        x7 += 2;

    }
    cout << "Enter number from 1 to 16: " << endl;
    cin >> x6;
    while (x6 <= 16)
    {
        cout << "x6 = " << x6 << " x6^2= " << x6 * x6 << endl;
        x6 += 1;

    }



    // цикл do/while (делать, пока)
    /*Практически идентичен циклу while*/

    int x8 = 1;
    do
    {
        cout << "x = " << x8 << endl;
        x8++;

    } while (x8 <= 5);
    cout << "end of programm" << endl;
    /*Разница с просто циклом while, означает, что программа всегда делает, хотя бы один раз цикл, в отличие просто от цикла while, где тело цикла
    while может быть пропущено, если условия введены некорректные = false*/


    // цикл for
    /*цикл for очень похож на цикл while,но структура немного отличается */

    /* for (int x = 1; x <= 5; x++)
    {

     cout<<x<<endl;

    }

    для цикла for мы все условия, все три утверждения вписываем сразу в него, у while условия вписаны как вне, так и снаружи
    цикл for исполняется всегда, хотя бы один раз
    */

    int sum = 0;
    for (int x = 1; x <= 10; x++)
    {
        sum += x;
        cout << "sum = " << sum << endl;
    }

    for (int x = 6; x <= 30; x += 6)
    {


        cout << "x =: " << x << endl;
    }
    for (int x = 2; x <= 100; x += 2)
    {
        cout << "another for cycle = " << x << endl;
    }
    for (int x = 1; x <= 16; x++)
    {
        cout << "x=  " << x << " x * x = " << x * x << endl;
    }

    //функции
    //функции необходимы для использования кода несколько раз, без постоянного переписывания его каждый раз

    double rootOf5 = sqrt(5); // вызываем функцию sqrt - это квадратный корень в C++
    cout << rootOf5 << endl;

    /*Я создал функцию  printRoad() в начале старницы вне int main, в самом main я вызвал функцию по названию printRoad(), тем самым функция вызвалась
    и сработала. Функции создаются отдельно от исполняющего файла и  используют тип void, чтобы не исполнялись юез необходимости, а просто существовали отдельно,
    т.е. были занесены в базу данных*/
    
    
    cout << "start function printRoad():" << endl;
    printRoad(1);
    cout << "function finished" << endl;



    printRoad(2);  //вызываем функцию несколько раз, тем самым нам не придется писать тело функции четыре раза
    printRoad(3);
    printRoad(1);// вписывая цифры в скобки мы по сути приравниваем int numSegments = 1
    printRoad(0);

    for (int i = 0; i < 4; i++) //в данном случае с помощью цикла for можно также вызвать printRoad() 4 раза, тем самым упростив ввод
        printRoad(1);  //данный способ ввода правильный для функции используемый с циклом for



    myFunction();

    cout << "sum of a and b = " <<summa(5,6)<<  endl; // в данном случае вызов результата функции может быть выведен только через cout,
    // т.к. cout в функции summa не обозначен и соответвственно результат return сам не выведется

    cout << isPositive(2) << endl;
    cout << getGrade(90) << endl;
   
    cout << getGrade(50) << endl;


    cout << absEqual(1,1) << endl;

    cout << mathfunction(1) << endl;



    //глобальные переменные (начало программы)
    /*Задаются и заданы в данном случае в начале программы, строковая переменная создана в самом начале до все функций в программе
    string g_string; и созданы функции, которые также берут данные из глобальной переменной
    в примере ниже вызваны функции и выведены данные АВ АВС, функции выводя сследующее значение складывают предыдущее, 
    иногда программисты предпочитают ставить суффикс g_ для обозначения глобальной переменной, но это не являетс обязательным*/
    addA();
    addB();
    cout << g_string << endl;
    addC();
    cout << g_string << endl;

    /*Локальные переменные
    
    определены в блоке кода и работают только в той части кода, в которой они определены*/
    int x10=10; //локальная переменная внутри main, заканчивает свою работу после закрытия скобки main
    if (x10 == 10)
    {
        cout << "Local variable" << endl;
    }
    if (x10 == 0)
    {
        int y; // создается локальная переменная y, которая работает только внутри данных скобок
    }
    if (int x11 = x10) // создается локальная переменная х11 равная х10 внутри данного кода
    {
        cout << "x11 = x10 " << endl; //либо вводим данные если x10 не равен x11
    }       // x11 заканчивается здесь и используется локально только в данном теле кода

    for (int c = 0; c <= 4; c++) /*Созжается еще одна локальная переменная в цикле for, 
                                 которая будет работать только в данном коде*/
    {           //действие переменной с начинается здесь
        cout << c << endl;
    }           // заканчивается здесь


    /*g_int глобальная переменная целочисленного типа, действует с места объявления, т.е. с той строки, где она находится и до конца файла и это означает
    g_int может использоваться внутри func()  и main(), но не может использованься в других файлах, чтобы иметь одну глобальную переменную
    для использования в коде других файлах необходима внешняя переменная
    
    
    arg - аргумент функции func(argument) может использоваться с первой строки func() в открывающихся {} фигурных скобках и использоваться до конца func() 
    в конце {} фигурных скобок

    fx может использоваться где угодно внутри func() до закрывающейся фигурной скобки{}

    void func(int arg)
    {
    int fx;

    }

    также и с циклом for
    for(int c=0;c<=4;c++)  переменная с объявлена внутри цикла и может работать только до конца его действия
    {
    cout<<c<<endl;
    }                   здесь с заканчивается

    если хотим, чтобы с действовала дальше то ее необходимо объявлеть до начала действия цикла for

    int c = 0;     переменная объявлена до начала цикла
    for (c = 0; c<=4; c++)
    {
    cout<<c<<endl;
    }
                здесь переменная с продолжит свое существование
        
    */



    //статические функции
    /*используются только раз*/

    testFunc();  //статичная функция строка 39 функция выводит сколько раз она была выведена
    testFunc();
    /*статические локальные переменные подсчитывают сколько вы по факту раз запустили данную переменну, если мы уберем static в функции, функция будет 
    вносить данные что мы запустили данную функцию 1 раз, каждый так раз, а не подсчитыать каждый запуск функции
    рекомендуется не злоупотреблять статичными функциями и использовать их только при необходимости
   */

    // const переменные
    /*константная (постоянная) переменная данные переменные мы объявляем один раз и они являются постоянными для компилятора и не меняются
    */

    const double pi = 3.14159;
    //pi *= 2; при попытке поменять значение pi компилятор выдаст ошибку, сказав, что pi является константой и менять это значение мы не можем



    //Прототипы функций
    // прототипом функции является функция без тела, т.е. без {} фигурных скобок например bool absEqual(int a, int b);

     // это прототипы функций, которые не содержат тела функции {} т.е. нет фигурных скобок
    //bool absEqual(int a, int b);        // обычно тело функции располагается в .h файле, а тело в .cpp файле
    //char getGrade(int grade);        // причина, в том, чтобы включить .h файл в .срр файл и не получить множество ошибок определения




    // Переменные extern
    /*Объявление extern схоже с прототипом функции, но применяется к переменным
    можно расположить объявление глобальной переменной в файле .h и включить этот .h файл во всю связку других файлов, тем самым пременная будет глобальной
    для всех файлов программы, объявление глобальной переменной происходит в файле .cpp*/




    // Макросы
    /*Макросы команд выходят из класса команд С++ называемых директивами препроцессора. Директивы препроцессора выполняются до компиляции
        Макросы начинаются с #define к примеру есть макрос #define Pi 3.14159 он был определен в начале данного файла*/

    double r = 4;
    
    cout <<"round = "<<2 * Pi * r << endl; //здесь Pi подсвечен как макрос (цвет макроса #define), который мы определили в начале файла 
    // Pi поменялся на 3.14159 как определено в макросе, тем самым подсчитав окружность
    //макросы можно использовать для определения постоянных переменных вместо const (константы), но так же можно применять и константы
    // константы это тоже всегда очень хорошо, тем более при использоввании const мы определяем переменную в данном случае double
    // const double = 3.14159; определенные переменные это всегда хорошо, в макросе переменная же не определена



    //Макросы с аргументами
    /*Мы также можем писать макросы с аргументами к примеру
    #define printIn(X) cout << X <<endl;
    */


    printIn("Hello i'm macros with an argument") /*Макрос выводит значение, макрос является по сути короткой функцией  макрос не имеет символов и разделителей строк*/


        /*В процессе программирования можно будет часто встретиться с макросами, но иногда программисты предпочитают встроенные функции,
        которые как правило используют в коротких программах
        */
        //inline int max(int a, int b) //встроенная функция, используется вместо макроса, особенно вместо большого макроса
  //  {                           // у встроенной функции копируются строки в место вызова, тем самым переход не требуется
    //    if (a > b) return a;
        //применение встроенных функций обычно имеет смысл для маленьких, простых функций, которые имеют не большое количество строк
    //    else return b;

  //  }
        //inline определяет встроенную функцию

        max(2, 4); // данная встроенная функция не выводит ничего, но ее можно использовать в другой функции для решения, т.к. все строки функции
                        // перенесутся в ту функцию, где она была вызвана
    /*Встроенные функции эффективны подобно макросам 
    Есть ухищрение по использованию встроенных функций. Встроенные функции должны иметь свое собственное тело, полностью содержащееся в заголовочном файле .h
    Так компилятор может производить оптимизацию и собственно встраивать функцию туда, где она используется. Функции делаются встроенными только ради скорости
    (посколько не придется переходить к другому телу кода, чтобы выполнить функцию), но ценойразрастания кода*/

    /*Причины, что встроенные функции предпочтительнее макросов:
        1. Макросы предрасположены к ошибкам: не обозначен аргумент макроса
        2. Макросы должны быть выполнены на одной строке иначе их придется читать с переходом строки используя символы \, а это усложняет
        процесс чтения макроса
        3. Если макрос будет написан неверно, то это может вызвать большие сложности для компилятора, что в итоге приведет к ошибке,
        а это будет очень сложно исправить, если к примеру неправильно поместить в скобки аргумент, то код будет неправильным
        4. Большой макрос трудно отлаживать*/


    // Глава 6 
    //Объекты, классы и наследование
    // struct является по сути одной большой переменной, которая связывает более мелкие переменные в начале файла есть struct Player{string name; int hp;};

    // Функция-член 
    /*Мы можем записать функцию член в сам struct Player, просто записав эту функцию внутрь*/


    // Ключевое слово this
    // this->hp -= amount; //ключевое слово this - это указатель, действующий на текущий объект, this имеет смысл только внутри функции-члена
    // без написания this имеется ввиду, что мы говорим о hp данного объекта
    // пример struct Player в начале файла




    // строковые типы являются объектами
    string smm= "strings are objects"; // создали строковый тип smm 
    smm.append("!!"); // добавили !! к строке smm, append() - это функция член, через ctrl+пробел можно всегда посмотреть функцию член,
                            //ставим название объекта затем ., пример smm.
    cout << smm << endl;// Получили strings are objects!!
    


    // функция-член всегда запускается по следующей программе
    // objectName.memberFunction() -  где слева от точки это тот объекта, который запускает функцию-член, а справа сама функция член, которая всегда имеет () скобки
    // если скобки не проставить, то функция-член не сработает

    Player player;
    player.damage(15); // игрок получает урон 15 единиц либо
    player.hp -= 15; // аналогичный вариант игрок получает 15 единиц урона
    player.armorClass;

    player.hp -= 15 - player.armorClass; /* не объектно ориентированный вариант кодирования в начале приведен объектно ориентированный вариант написания программы,
     это плохой вариант работы кода, т.к. напрямую дает возможность его изменить, наилучшим образом будет все делать с помощью объектно ориентированного 
        программирования (ООП)
                                    */
                                            // ООП расписан выше в struct Player

    
                                            
                       //  Инкапсуляция
    /*Наиболее выгодным вариантом при программировании является программирование через объекты, особенно в языке С++, и чтобы у нас была возможность
    изменить данные в объекте, который мы создали придумали инкапсуляцию*/
    /*Инкапсуляция - концепция, по которой взаимодествие с каждым объектном должно осуществляться только посредством функций-членов. нкапсуляция говорит,
    что необработанные элементы данных, должны быть недоступны напрямую
    
    Инкапсуляция нужна, чтобы сделать содержание класса безопасным и мы не могли случайно изменить какие-либо данные, по сути класс/структура, которые мы создали
    все функции и переменные, которые записаны внутри объекта, т.е. в теле защищены от случайного изменения
    
    также инкапсуляция нужна для избежания нарушений кода

       
    */


    /*Public и Private*/
    /*Public - публичная часть объекта, т.е. все данные, которые мы заносим в public мы можем менять извне
    Private - это непубличный блок кода, т.е. данные, которые находятся в нем просто так изменить не получится, это по сути более защищенные данные, чем Public
    в начале в классе struct Player мы разбили его на Private и Public*/
    



    // Class
    /*Аналогично struct существует струтктура типа class, с помощью данной команды мы можем объявить объект class Player, применяется вместо struct
    
    class vs struct
    
    отличия между class и struct только в том, что объекты в struct изначально по умолчанию являются публичными, а в class данные изначально объявлены как private
    Именно поэтому все было введено через struct в данном учебном примере.
    
    в основном struct предпочтительны для простых типов, которые не используют инкапсуляцию, имеют не много функций-членов и должны быть обратно совместимы с языком С
    Классы же используются все еще повсюду
    
    Далее будем использовать class вместо struct*/


    // Геттеры и сеттеры (set и get)
    /*Геттер - получатель (известен как функция доступа), используется, чтобы передавать обратно вызывающему, копии внутренних элементов данных.
    Чтобы считать имя игрока, мы украшаем класс Player функцией членом специально, чтобы извлечь копию этого частного (private) элемента данных*/

    Player1 player1;

    cout << player1.getName() << endl; // здесь мы обращаемся к объекту Player1 и извлекаем из него private данные

    /*Сеттер - установщик(также известен, как модификатор функции или мутатор функции), функция член, чьей единственной целью является изменения значения
    внутренней переменной в классе, те саммым мы можем менять частную (private) функцию класса, извне только если мы это делаем через функцию сеттер*/


    /*Некоторые программисты считают, что использование get() и set() не является хорошим тоном в программировании и предпочитают использовать стандартное написание
    более высоких функций*/

    /*
    
     метод мутатора (геттера или сеттера) предполагает предотвращение принятия отрицательного значения внутренним элементом данных hp,
      можно также рассматривать метод мутатора отчасти имеющим обратную силу

      Идея метода мутатора в том, что вызывающий код может передавать любое значение, передаваемое функции, пригодным или нет. Затем функция setHP принимает
      ответственность в том, чтобы убедиться является ли значение для переменной hp пригодным как в примере ниже:
    
    void setHP(int newHP)      
    {
        if (newHP < 0)
        {
            cout << "Hp cannot be less than 0" << endl;
            newHP = 0;
        }
        hp = newHP;
    }
       
    */



    // Конструкторы и Деструкторы

    /**/




 }                       







